/** MIT License
* 
* Copyright (c) 2018 Ludovic CLUBER 
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* http://csvxjs.lcluber.com
*/

var CSVx=function(e){"use strict";function r(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}var t=function(){function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,t,n){return t&&r(e.prototype,t),n&&r(e,n),e}}(),n=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return t(e,null,[{key:"get",value:function(e){return this.call("GET",e)}},{key:"head",value:function(e){return this.call("HEAD",e)}},{key:"post",value:function(e){return this.call("POST",e)}},{key:"put",value:function(e){return this.call("PUT",e)}},{key:"delete",value:function(e){return this.call("DELETE",e)}},{key:"connect",value:function(e){return this.call("CONNECT",e)}},{key:"options",value:function(e){return this.call("OPTIONS",e)}},{key:"trace",value:function(e){return this.call("TRACE",e)}},{key:"patch",value:function(e){return this.call("PATCH",e)}},{key:"call",value:function(r,o){var i=this;return new Promise(function(e,t){var n=new XMLHttpRequest;i.noCache&&(o+="?cache="+(new Date).getTime()),n.open(r,o,i.async),n.setRequestHeader("Content-Type","application/x-www-form-urlencoded"),n.onreadystatechange=function(){4==n.readyState&&(200==n.status?e(n.responseText):t(n.status))},n.send()})}}]),e}();n.async=!0,n.noCache=!1;var o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},i=function(){function r(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}return function(e,t,n){return t&&r(e.prototype,t),n&&r(e,n),e}}(),c=function(){function e(){r(this,e)}return i(e,null,[{key:"isJSON",value:function(e){if(!this.isString(e))return!1;var t=e.replace(/(\r\n|\n|\r|\t)/gm,"");try{t=JSON.parse(e)}catch(e){return!1}return t}},{key:"isFunction",value:function(e){return e&&"[object Function]"==={}.toString.call(e)}},{key:"isObject",value:function(e){return null!==e&&"object"===(void 0===e?"undefined":o(e))}},{key:"isASCII",value:function(e,t){return(t?/^[\x00-\xFF]*$/:/^[\x00-\x7F]*$/).test(e)}},{key:"isInteger",value:function(e){return e===parseInt(e,10)}},{key:"isString",value:function(e){return"string"==typeof e}}]),e}(),u=function(){function e(){r(this,e)}return i(e,null,[{key:"scrollToBottom",value:function(e){e.scrollTop=e.scrollHeight}},{key:"findById",value:function(e){return document.getElementById(e)}},{key:"showById",value:function(e){this.findById(e).style.display="block"}},{key:"hideById",value:function(e){this.findById(e).style.display="none"}},{key:"showOverflow",value:function(){document.body.style.overflow="visible"}},{key:"hideOverflow",value:function(){document.body.style.overflow="hidden"}},{key:"getInputValue",value:function(e){return this.findById(e).value}},{key:"clearInputValue",value:function(e){this.findById(e).value=""}},{key:"focusOn",value:function(e){this.findById(e).focus()}},{key:"addHTMLElement",value:function(e,t,n){var r=document.createElement(t);return void 0!==n&&Object.keys(n).forEach(function(e){"textContent"===e||"innerHTML"===e?r[e]=n[e]:r.setAttribute(e,n[e])}),e.appendChild(r),r}}]),e}(),a=(function(){function n(e,t){r(this,n),this.data=t,this.element=e,this.element.value=t,this.element.addEventListener("change",this,!1)}i(n,[{key:"handleEvent",value:function(e){switch(e.type){case"change":this.change(this.element.value)}}},{key:"change",value:function(e){this.data=e,this.element.value=e}}])}(),function(){function e(){r(this,e)}i(e,null,[{key:"ucfirst",value:function(e){return e.charAt(0).toUpperCase()+e.slice(1)}},{key:"toASCII",value:function(e){return e.charCodeAt(0)}}])}(),function(){function e(){r(this,e)}return i(e,null,[{key:"load",value:function(e){return n.get(e)}},{key:"removeTrailingSlash",value:function(e){return e.replace(/\/+$/,"")}},{key:"getName",value:function(e){return e.replace(/^.*[\\\/]/,"")}},{key:"getExtension",value:function(e){return e.split(".").pop()}},{key:"getDirectory",value:function(e){return e.replace(/[^\\\/]*$/,"")}},{key:"checkExtension",value:function(e,t){var n=!0,r=!1,o=void 0;try{for(var i,u=t[Symbol.iterator]();!(n=(i=u.next()).done);n=!0){if(e===i.value)return!0}}catch(e){r=!0,o=e}finally{try{!n&&u.return&&u.return()}finally{if(r)throw o}}return!1}}]),e}()),l=(function(){function e(){r(this,e)}i(e,null,[{key:"load",value:function(r){return new Promise(function(e,t){var n=new Image;n.src=r,n.name=a.getName(r),n.addEventListener("load",function(){e(n)}),n.addEventListener("error",function(){t(new Error("xhr failed ("+r+")"))})})}}])}(),function(){function e(){r(this,e)}i(e,null,[{key:"load",value:function(r){return new Promise(function(e,t){var n=new Audio;n.src=r,n.addEventListener("canplaythrough",function(){e(n)},!1),n.addEventListener("canplay",function(){e(n)},!1),n.addEventListener("error",function(){t(new Error("xhr failed ("+r+")"))},!1)})}}])}(),function(){function e(){}return e.fromObject=function(e,t,n){if(!c.isObject(t[0])&&!c.isJSON(t[0]))return!1;n&&this.setOptions(n);var r="data:"+this.options.data+";charset="+this.options.charset+",";return this.options.labels&&(r+=this.createLabels(t)),r+=this.createTable(t),this.download(r,e),!0},e.setOptions=function(e){for(var t in e)e.hasOwnProperty(t)&&this.options.hasOwnProperty(t)&&(this.options[t]=e[t])},e.download=function(e,t){var n=encodeURI(e),r=u.addHTMLElement(document.body,"a",{href:n,download:t+".csv"});r.click(),document.body.removeChild(r)},e.createTable=function(e){for(var t="",n=0,r=e;n<r.length;n++){var o=r[n],i=c.isJSON(o)||o;if(!c.isObject(i))return t;var u="";for(var a in i)i.hasOwnProperty(a)&&(u+=this.createField(i[a]));t+=this.createRow(u)}return t},e.createLabels=function(e){var t=c.isJSON(e[0])||e[0],n="";for(var r in t)t.hasOwnProperty(r)&&(n+=this.createField(r));return this.createRow(n)},e.createRow=function(e){return e+this.options.CRLF},e.createField=function(e){return this.options.quote+e+this.options.quote+this.options.separator},e.options={data:"text/csv",charset:"utf-8",labels:!0,quote:'"',separator:",",CRLF:"\r\n"},e}());return e.Export=l,e}({});